using System;
using System.Drawing;
using System.Collections;

// ABB namespaces
using ABB.Robotics.Controllers;
using ABB.Robotics.Tps.Taf;
using ABB.Robotics.Tps.Windows.Forms;

// Compliance Tool Info 
[assembly: TpsView("RapiddataBindingSample", "tpu-Operator32.gif", "tpu-Operator16.gif", "TpsViewIRC5DataBinding.dll", "TpsViewIRC5DataBinding.TpsViewIRC5DataBinding", StartPanelLocation.Left, TpsViewType.Static, TpsViewStartupTypes.Manual)]
namespace TpsViewIRC5DataBinding
{
    /// <summary>
    /// Summary description for TpsViewIRC5App1.
    /// </summary>
    public class TpsViewIRC5DataBinding : TpsForm, ITpsViewSetup, ITpsViewActivation
    {
        private GroupBox groupBox1;
        private TextBox textBox4;
        private TextBox textBox3;
        private TextBox textBox2;
        private TextBox textBox1;
        private ABB.Robotics.DataBinding.RapidDataBindingSource rapidDataBindingSource1;
        private TpsLabel tpsLabel4;
        private TpsLabel tpsLabel3;
        private TpsLabel tpsLabel2;
        private TpsLabel tpsLabel1;
        private CommandBar commandBar1;
        private MenuItem menuItem1;
        private MenuItem menuItem2;
        private System.Windows.Forms.DataGrid dataGrid1;
        private ABB.Robotics.Tps.Taf.ITpsViewLaunchServices _launchService;
        private System.Windows.Forms.DataGridTableStyle dataGridTableStyle1;
        private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn1;
        private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn2;
        private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn3;
        private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn4;
        private object _cookie;

        public TpsViewIRC5DataBinding()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.menuItem2.Click += new EventHandler(menuItem2_Click);

            //
            // ToDo: Add any constructor code after InitializeComponent call
            //
        }

      private  void menuItem2_Click(object sender, EventArgs e)
        {
            if (_launchService.LaunchView(ABB.Robotics.Tps.Taf.FpStandardView.RapidData, null, true, out this._cookie) != true)
            {
                GTPUMessageBox.Show(this, null, "Could not start Program data view");
                return;
            }


        }
        /// <summary>
        /// This is where you clean up any remaining resources used by your application before 
        /// the application itself is disposed of by TAF (TeachPendant Application Framework). 
        /// The method is called by TAF when the application is closed down.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (!IsDisposed)
            {
                try
                {
                    if (disposing)
                    {
                        if (rapidDataBindingSource1 != null)
                        {
                            rapidDataBindingSource1.Dispose();
                            rapidDataBindingSource1 = null;
                        }
                        //ToDo: Call the Dispose method of all FP SDK instances that may otherwise cause memory leak
                    }
                }
                finally
                {
                    base.Dispose(disposing);
                }
            }
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            ABB.Robotics.DataBinding.RapidDataObject rapidDataObject1 = new ABB.Robotics.DataBinding.RapidDataObject();
            ABB.Robotics.DataBinding.RapidDataObject rapidDataObject2 = new ABB.Robotics.DataBinding.RapidDataObject();
            ABB.Robotics.DataBinding.RapidDataObject rapidDataObject3 = new ABB.Robotics.DataBinding.RapidDataObject();
            ABB.Robotics.DataBinding.RapidDataObject rapidDataObject4 = new ABB.Robotics.DataBinding.RapidDataObject();
            this.groupBox1 = new ABB.Robotics.Tps.Windows.Forms.GroupBox();
            this.tpsLabel4 = new ABB.Robotics.Tps.Windows.Forms.TpsLabel();
            this.tpsLabel3 = new ABB.Robotics.Tps.Windows.Forms.TpsLabel();
            this.tpsLabel2 = new ABB.Robotics.Tps.Windows.Forms.TpsLabel();
            this.tpsLabel1 = new ABB.Robotics.Tps.Windows.Forms.TpsLabel();
            this.textBox4 = new ABB.Robotics.Tps.Windows.Forms.TextBox();
            this.rapidDataBindingSource1 = new ABB.Robotics.DataBinding.RapidDataBindingSource();
            this.textBox3 = new ABB.Robotics.Tps.Windows.Forms.TextBox();
            this.textBox2 = new ABB.Robotics.Tps.Windows.Forms.TextBox();
            this.textBox1 = new ABB.Robotics.Tps.Windows.Forms.TextBox();
            this.dataGrid1 = new System.Windows.Forms.DataGrid();
            this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
            this.dataGridTextBoxColumn1 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.dataGridTextBoxColumn2 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.dataGridTextBoxColumn3 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.dataGridTextBoxColumn4 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.commandBar1 = new ABB.Robotics.Tps.Windows.Forms.CommandBar();
            this.menuItem1 = new ABB.Robotics.Tps.Windows.Forms.MenuItem();
            this.menuItem2 = new ABB.Robotics.Tps.Windows.Forms.MenuItem();
            this.groupBox1.SuspendLayout();
            this.rapidDataBindingSource1.BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.rapidDataBindingSource1)).BeginInit();
            this.SuspendLayout();
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.tpsLabel4);
            this.groupBox1.Controls.Add(this.tpsLabel3);
            this.groupBox1.Controls.Add(this.tpsLabel2);
            this.groupBox1.Controls.Add(this.tpsLabel1);
            this.groupBox1.Controls.Add(this.textBox4);
            this.groupBox1.Controls.Add(this.textBox3);
            this.groupBox1.Controls.Add(this.textBox2);
            this.groupBox1.Controls.Add(this.textBox1);
            this.groupBox1.Controls.Add(this.dataGrid1);
            this.groupBox1.HorizontalAlign = ABB.Robotics.Tps.Windows.Forms.HorAlign.Left;
            this.groupBox1.LineStyle = ABB.Robotics.Tps.Windows.Forms.LineStyle.SingleLine;
            this.groupBox1.Location = new System.Drawing.Point(17, 44);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(602, 304);
            this.groupBox1.Title = "My Rapid Data";
            this.groupBox1.VerticalAlign = ABB.Robotics.Tps.Windows.Forms.VerAlign.Center;
            // 
            // tpsLabel4
            // 
            this.tpsLabel4.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tpsLabel4.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.tpsLabel4.Location = new System.Drawing.Point(350, 210);
            this.tpsLabel4.Multiline = true;
            this.tpsLabel4.Size = new System.Drawing.Size(121, 24);
            this.tpsLabel4.TabIndex = 12;
            this.tpsLabel4.TextAlignment = System.Drawing.ContentAlignment.TopLeft;
            this.tpsLabel4.Title = "Task name:";
            // 
            // tpsLabel3
            // 
            this.tpsLabel3.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tpsLabel3.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.tpsLabel3.Location = new System.Drawing.Point(350, 167);
            this.tpsLabel3.Multiline = true;
            this.tpsLabel3.Size = new System.Drawing.Size(131, 24);
            this.tpsLabel3.TabIndex = 11;
            this.tpsLabel3.TextAlignment = System.Drawing.ContentAlignment.TopLeft;
            this.tpsLabel3.Title = "Module name:";
            // 
            // tpsLabel2
            // 
            this.tpsLabel2.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tpsLabel2.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.tpsLabel2.Location = new System.Drawing.Point(350, 119);
            this.tpsLabel2.Multiline = true;
            this.tpsLabel2.Size = new System.Drawing.Size(131, 24);
            this.tpsLabel2.TabIndex = 10;
            this.tpsLabel2.TextAlignment = System.Drawing.ContentAlignment.TopLeft;
            this.tpsLabel2.Title = "Variable name:";
            // 
            // tpsLabel1
            // 
            this.tpsLabel1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tpsLabel1.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.tpsLabel1.Location = new System.Drawing.Point(350, 76);
            this.tpsLabel1.Multiline = true;
            this.tpsLabel1.Size = new System.Drawing.Size(131, 24);
            this.tpsLabel1.TabIndex = 9;
            this.tpsLabel1.TextAlignment = System.Drawing.ContentAlignment.TopLeft;
            this.tpsLabel1.Title = "Current Value:";
            // 
            // textBox4
            // 
            this.textBox4.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox4.CaretVisible = false;
            this.textBox4.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.rapidDataBindingSource1, "TaskName", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
            this.textBox4.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.textBox4.Location = new System.Drawing.Point(473, 210);
            this.textBox4.Multiline = true;
            this.textBox4.ScrollBars = System.Windows.Forms.ScrollBars.None;
            this.textBox4.SelectionLength = 0;
            this.textBox4.SelectionStart = 0;
            this.textBox4.SelectionVisible = false;
            this.textBox4.Size = new System.Drawing.Size(98, 25);
            this.textBox4.TabIndex = 8;
            this.textBox4.Text = "";
            this.textBox4.TextAlign = System.Windows.Forms.HorizontalAlignment.Left;
            this.textBox4.WordWrap = true;
            // 
            // rapidDataBindingSource1
            // 
            this.rapidDataBindingSource1.DataSource = typeof(ABB.Robotics.DataBinding.RapidDataObject);
            rapidDataObject1.ModuleName = "user";
            rapidDataObject1.TaskName = "T_ROB1";
            rapidDataObject1.VariableName = "myNum";
            rapidDataObject2.ModuleName = "user";
            rapidDataObject2.TaskName = "T_ROB1";
            rapidDataObject2.VariableName = "num1";
            rapidDataObject3.ModuleName = "user";
            rapidDataObject3.TaskName = "T_ROB2";
            rapidDataObject3.VariableName = "flag";
            rapidDataObject4.ModuleName = "user";
            rapidDataObject4.TaskName = "T_ROB2";
            rapidDataObject4.VariableName = "num3";
            this.rapidDataBindingSource1.RapidDataList.Add(rapidDataObject1);
            this.rapidDataBindingSource1.RapidDataList.Add(rapidDataObject2);
            this.rapidDataBindingSource1.RapidDataList.Add(rapidDataObject3);
            this.rapidDataBindingSource1.RapidDataList.Add(rapidDataObject4);
            // 
            // textBox3
            // 
            this.textBox3.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox3.CaretVisible = false;
            this.textBox3.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.rapidDataBindingSource1, "ModuleName", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
            this.textBox3.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.textBox3.Location = new System.Drawing.Point(485, 167);
            this.textBox3.Multiline = true;
            this.textBox3.ScrollBars = System.Windows.Forms.ScrollBars.None;
            this.textBox3.SelectionLength = 0;
            this.textBox3.SelectionStart = 0;
            this.textBox3.SelectionVisible = false;
            this.textBox3.Size = new System.Drawing.Size(86, 24);
            this.textBox3.TabIndex = 7;
            this.textBox3.Text = "";
            this.textBox3.TextAlign = System.Windows.Forms.HorizontalAlignment.Left;
            this.textBox3.WordWrap = true;
            // 
            // textBox2
            // 
            this.textBox2.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox2.CaretVisible = false;
            this.textBox2.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.rapidDataBindingSource1, "VariableName", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
            this.textBox2.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.textBox2.Location = new System.Drawing.Point(487, 76);
            this.textBox2.Multiline = true;
            this.textBox2.ScrollBars = System.Windows.Forms.ScrollBars.None;
            this.textBox2.SelectionLength = 0;
            this.textBox2.SelectionStart = 0;
            this.textBox2.SelectionVisible = false;
            this.textBox2.Size = new System.Drawing.Size(88, 24);
            this.textBox2.TabIndex = 6;
            this.textBox2.Text = "";
            this.textBox2.TextAlign = System.Windows.Forms.HorizontalAlignment.Left;
            this.textBox2.WordWrap = true;
            // 
            // textBox1
            // 
            this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox1.CaretVisible = false;
            this.textBox1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.rapidDataBindingSource1, "Value", true, System.Windows.Forms.DataSourceUpdateMode.OnPropertyChanged));
            this.textBox1.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.textBox1.Location = new System.Drawing.Point(487, 119);
            this.textBox1.Multiline = true;
            this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.None;
            this.textBox1.SelectionLength = 0;
            this.textBox1.SelectionStart = 0;
            this.textBox1.SelectionVisible = false;
            this.textBox1.Size = new System.Drawing.Size(84, 24);
            this.textBox1.TabIndex = 5;
            this.textBox1.Text = "";
            this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Left;
            this.textBox1.WordWrap = true;
            // 
            // dataGrid1
            // 
            this.dataGrid1.BackgroundColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(128)))), ((int)(((byte)(128)))));
            this.dataGrid1.DataSource = this.rapidDataBindingSource1;
            this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ActiveCaption;
            this.dataGrid1.Location = new System.Drawing.Point(13, 67);
            this.dataGrid1.Name = "dataGrid1";
            this.dataGrid1.SelectionForeColor = System.Drawing.SystemColors.ControlLightLight;
            this.dataGrid1.Size = new System.Drawing.Size(321, 197);
            this.dataGrid1.TabIndex = 0;
            this.dataGrid1.TableStyles.Add(this.dataGridTableStyle1);
            // 
            // dataGridTableStyle1
            // 
            this.dataGridTableStyle1.GridColumnStyles.Add(this.dataGridTextBoxColumn1);
            this.dataGridTableStyle1.GridColumnStyles.Add(this.dataGridTextBoxColumn2);
            this.dataGridTableStyle1.GridColumnStyles.Add(this.dataGridTextBoxColumn3);
            this.dataGridTableStyle1.GridColumnStyles.Add(this.dataGridTextBoxColumn4);
            // 
            // dataGridTextBoxColumn1
            // 
            this.dataGridTextBoxColumn1.Format = "";
            this.dataGridTextBoxColumn1.FormatInfo = null;
            this.dataGridTextBoxColumn1.HeaderText = "Value";
            // 
            // dataGridTextBoxColumn2
            // 
            this.dataGridTextBoxColumn2.Format = "";
            this.dataGridTextBoxColumn2.FormatInfo = null;
            this.dataGridTextBoxColumn2.HeaderText = "Variable";
            // 
            // dataGridTextBoxColumn3
            // 
            this.dataGridTextBoxColumn3.Format = "";
            this.dataGridTextBoxColumn3.FormatInfo = null;
            this.dataGridTextBoxColumn3.HeaderText = "Module";
            // 
            // dataGridTextBoxColumn4
            // 
            this.dataGridTextBoxColumn4.Format = "";
            this.dataGridTextBoxColumn4.FormatInfo = null;
            this.dataGridTextBoxColumn4.HeaderText = "Task";
            // 
            // commandBar1
            // 
            this.commandBar1.Font = ABB.Robotics.Tps.Windows.Forms.TpsFont.Font12b;
            this.commandBar1.Location = new System.Drawing.Point(17, 343);
            this.commandBar1.MenuItems.Add(this.menuItem1);
            this.commandBar1.Size = new System.Drawing.Size(602, 44);
            this.commandBar1.TabIndex = 3;
            // 
            // menuItem1
            // 
            this.menuItem1.Checked = false;
            this.menuItem1.DockToRight = false;
            this.menuItem1.Enabled = true;
            this.menuItem1.Image = null;
            this.menuItem1.ImageSelected = null;
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.Add(this.menuItem2);
            this.menuItem1.Pressed = false;
            this.menuItem1.Text = "Show View";
            this.menuItem1.Width = 128;
            // 
            // menuItem2
            // 
            this.menuItem2.Checked = false;
            this.menuItem2.DockToRight = false;
            this.menuItem2.Enabled = true;
            this.menuItem2.Image = null;
            this.menuItem2.ImageSelected = null;
            this.menuItem2.Index = 0;
            this.menuItem2.Pressed = false;
            this.menuItem2.Text = "Program Data";
            this.menuItem2.Width = 128;
            // 
            // TpsViewIRC5DataBinding
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.commandBar1);
            this.Size = new System.Drawing.Size(640, 390);
            this.Controls.SetChildIndex(this.commandBar1, 0);
            this.Controls.SetChildIndex(this.groupBox1, 0);
            this.groupBox1.ResumeLayout(false);
            this.rapidDataBindingSource1.EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.rapidDataBindingSource1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        #region ITpsViewSetup Members

        /// <summary>
        /// This method is called by TAF when the control is closed down (before Dispose is called).
        /// </summary>	
        void ITpsViewSetup.Uninstall()
        {
            // TODO:  Add TpsViewIRC5DataBinding.Uninstall implementation
        }

        /// <summary>
        /// This method is called by TAF when the control is installed in the framework (after the constructor is called).
        /// </summary>				
        bool ITpsViewSetup.Install(object sender, object data)
        {
            // TODO:  Add TpsViewIRC5DataBinding.Install implementation
            if (sender is ITpsViewLaunchServices)
            {
                this._launchService = sender as ITpsViewLaunchServices;
                return true;
            }
            return false;
        }

        #endregion

        #region ITpsViewActivation Members

        /// <summary>
        /// This method is called by TAF when the control goes from the active state to the passive state, 
        /// and is no longer visible in the client view. This happens when the user presses another application button 
        /// on the task bar, or closes the application. Normally, any subscriptions to controller events are removed here.
        /// </summary>				
        void ITpsViewActivation.Deactivate()
        {
            // TODO:  Add TpsViewIRC5DataBinding.Deactivate implementation
        }

        /// <summary>
        /// This method is called by TAF when the control goes from the passive state to the active state, 
        /// i.e. becomes visible in the client view. Normally, this is where subscriptions to controller events are set up.
        /// </summary>				
        void ITpsViewActivation.Activate()
        {
            // TODO:  Add TpsViewIRC5DataBinding.Activate implementation
        }

        #endregion

    }
}
